/* bootpack.c */
/* MOGEX */

#include "../main/bootpack.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define KEYCMD_LED		0xed
struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
extern struct MOUSE_INFO minfo;
char cpath[256], epath[1024];
struct TASK *fdc, *inout;
struct SHEET *ActiveSheet;
struct SHTCTL *shtctl;

void keywin_off(struct SHEET *key_win);
void keywin_on(struct SHEET *key_win);
void close_console(struct SHEET *sht);
void close_constask(struct TASK *task);
void sysclock_task(void);

void HariMain(void)
{
	char s[40];
	struct FIFO32 fifo, keycmd;
	int fifobuf[128], keycmd_buf[32];
	int mx, my, i, new_mx = -1, new_my = 0, new_wx = 0x7fffffff, new_wy = 0;
	unsigned int memtotal;
	struct MOUSE_DEC mdec;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *buf_back, buf_mouse[256], *buf_button;
	struct SHEET *sht_back, *sht_mouse, *sht_button, *sht_menu = NULL;
	struct TASK *task_a, *task;
	static char keytable0[0x80] = {
		0,   0,   '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '^', 0x08, 0,
		'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '@', '[', 0x0a, 0, 'a', 's',
		'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', ':', 0,   0,   ']', 'z', 'x', 'c', 'v',
		'B', 'N', 'M', ',', '.', '/', 0,   '*', 0,   ' ', 0,   0,   0,   0,   0,   0,
		0,   0,   0,   0,   0,   0,   0,   0, '8', 0, 0, '4', 0, '6', 0, 0,
		'2', 0, 0, 0, 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
		0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
		0,   0,   0,   0x5c, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0x5c, 0,  0
	};
	static char keytable1[0x80] = {
		0,   0,   '!', 0x22, '#', '$', '%', '&', 0x27, '(', ')', '~', '=', '~', 0x08, 0,
		'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '`', '{', 0x0a, 0, 'A', 'S',
		'D', 'F', 'G', 'H', 'J', 'K', 'L', '+', '*', 0,   0,   '}', 'Z', 'X', 'C', 'V',
		'B', 'N', 'M', '<', '>', '?', 0,   '*', 0,   ' ', 0,   0,   0,   0,   0,   0,
		0,   0,   0,   0,   0,   0,   0,   '7', '8', '9', '-', '4', '5', '6', '+', '1',
		'2', '3', '0', '.', 0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
		0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
		0,   0,   0,   '_', 0,   0,   0,   0,   0,   0,   0,   0,   0,   '|', 0,   0
	};
	int key_shift = 0, key_alt = 0, key_ctrl = 0, key_leds = (binfo->leds >> 4) & 7, keycmd_wait = -1;
	int j, x, y, mmx = -1, mmy = -1, mmx2 = 0;
	struct SHEET *sht = 0, *sht2;
	int *fat;
	unsigned char *nihongo;
	struct FILEINFO *finfo;
	extern char hankaku[4096];
	extern char mgxfont[4096];
	int menuIsOn = 0;
	int menuIsClosed = 0;

	init_gdtidt();
	init_pic();
	io_sti(); /* IDT/PIC̏ÎCPŮ荞݋֎~ */
	fifo32_init(&fifo, 128, fifobuf, 0);
	*((int *) 0x0fec) = (int) &fifo;
	init_pit();
	init_keyboard(&fifo, 256);
	enable_mouse(&fifo, 512, &mdec);
	init_allowMouseKeyB();
	fifo32_init(&keycmd, 32, keycmd_buf, 0);

	memtotal = memtest(0x00400000, 0xbfffffff);
	memman_init(memman);
	memman_free(memman, 0x00001000, 0x0009e000); /* 0x00001000 - 0x0009efff */
	memman_free(memman, 0x00400000, memtotal - 0x00400000);

	init_timerctl();
	init_palette();
	shtctl = shtctl_init(memman, binfo->vram, binfo->scrnx, binfo->scrny);

	task_a = task_init(memman);
	fifo.task = task_a;
	task_run(task_a, 1, 2);
	*((int *) 0x0fe4) = (int) shtctl;
	task_a->langmode = 0;

	/* FAT̏ */
	fat = init_fat("/");

	/* sht_back */
	/* ܂͋NʂoB */
	sht_back  = sheet_alloc(shtctl);
	buf_back  = (unsigned char *) memman_alloc_4k(memman, binfo->scrnx * binfo->scrny);
	sheet_setbuf(sht_back, buf_back, binfo->scrnx, binfo->scrny, -1); /* FȂ */
	load_screen8(fat, buf_back, binfo->scrnx, binfo->scrny);
	sheet_updown(sht_back,  0);

	/* FDC^XN̏ */
	fdc = task_alloc();
	int *fdc_fifo = (int *) memman_alloc_4k(memman, 2880 * 4 * 4);
	fdc->tss.esp = memman_alloc_4k(memman, 64 * 1024) + 64 * 1024;
	fdc->tss.eip = (int) &fdc_task;
	fdc->tss.es = 1 * 8;
	fdc->tss.cs = 2 * 8;
	fdc->tss.ss = 1 * 8;
	fdc->tss.ds = 1 * 8;
	fdc->tss.fs = 1 * 8;
	fdc->tss.gs = 1 * 8;
	fdc->time = 0;
	strcpy(fdc->name, "fdc");
	task_run(fdc, 2, 2); /* level=2, priority=2 */
	fifo32_init(&fdc->fifo, 2880 * 4, fdc_fifo, fdc);

	/* I/ORg[^XN̏ */
	inout = task_alloc();
	int *inout_fifo = (int *) memman_alloc_4k(memman, 128 * 4);
	inout->tss.esp = memman_alloc_4k(memman, 64 * 1024) + 64 * 1024 - 8;
	inout->tss.eip = (int) &inout_task;
	inout->tss.es = 1 * 8;
	inout->tss.cs = 2 * 8;
	inout->tss.ss = 1 * 8;
	inout->tss.ds = 1 * 8;
	inout->tss.fs = 1 * 8;
	inout->tss.gs = 1 * 8;
	inout->time = 0;
	strcpy(inout->name, "ioctrl");
	*((int *) (inout->tss.esp + 4)) = (int) sht_back;
	task_run(inout, 2, 2); /* level=2, priority=2 */
	fifo32_init(&inout->fifo, 128, inout_fifo, inout);

	/* v^XN̏ */
	struct TASK *clock = task_alloc();
	int *clock_fifo = (int *) memman_alloc_4k(memman, 128 * 4);
	clock->tss.esp = memman_alloc_4k(memman, 64 * 1024) + 64 * 1024;
	clock->tss.eip = (int) &sysclock_task;
	clock->tss.es = 1 * 8;
	clock->tss.cs = 2 * 8;
	clock->tss.ss = 1 * 8;
	clock->tss.ds = 1 * 8;
	clock->tss.fs = 1 * 8;
	clock->tss.gs = 1 * 8;
	strcpy(inout->name, "clock");
	task_run(clock, 1, 2); /* level=1, priority=2 */
	fifo32_init(&clock->fifo, 128, clock_fifo, clock);

	/* sht_mouse */
	/* }EXSheet */
	sht_mouse = sheet_alloc(shtctl);
	sheet_setbuf(sht_mouse, buf_mouse, 16, 16, 99);
	init_mouse_cursor8(buf_mouse, 99);
	mx = (binfo->scrnx - 16) / 2; /* ʒɂȂ悤ɍWvZ */
	my = (binfo->scrny - 28 - 16) / 2;

	/* ŏɃL[{[hԂƂ̐HႢȂ悤ɁAݒ肵ĂƂɂ */
	fifo32_put(&keycmd, KEYCMD_LED);
	fifo32_put(&keycmd, key_leds);

	/* nihongo.fnt̓ǂݍ */
	finfo = file_search(OS_FONTFNT, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	if (finfo != 0) {
		i = finfo->size;
		nihongo = file_loadfile2(finfo->clustno, &i, fat);
		for (i = 0; i < 16 * 256; i++) {
			nihongo[i] = mgxfont[i]; /* tHgȂ̂ŔpRs[ */
		}
	} else {
		nihongo = (unsigned char *) memman_alloc_4k(memman, 16 * 256 + 32 * 94 * 47);
		for (i = 0; i < 16 * 256; i++) {
			nihongo[i] = hankaku[i]; /* tHgȂ̂ŔpRs[ */
		}
		for (i = 16 * 256; i < 16 * 256 + 32 * 94 * 47; i++) {
			nihongo[i] = 0xff; /* tHgȂ̂őSp0xffŖߐs */
		}
	}
	*((int *) 0x0fe8) = (int) nihongo;

	/* fXNgbv̋N */
	sheet_setbuf(sht_back, buf_back, binfo->scrnx, binfo->scrny, -1); /* FȂ */
	init_qemuvga0(binfo, 640, 480, 16, 0xc1);
	init_screen8(fat, buf_back, binfo->scrnx, binfo->scrny);

	/* sht_button */
	sht_button = sheet_alloc(shtctl);
	buf_button = (unsigned char *) memman_alloc_4k(memman, 20*60);
	sheet_setbuf(sht_button, buf_button, 60, 20, -1);
	put_button(sht_button, menuIsOn);

	/* Wav̂Ă */
	//extern int wav_Is_error;
	//int ret;
	//finfo = file_search("mogex.wav", (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	//if (finfo != 0) {
	//	struct WAV_HEADER *wav;
	//	char *buf = file_loadfile2(finfo->clustno, &i, fat);
	//	char *string;

	//	wav = wave2pcm(buf, i);

	//	if (wav_Is_error == 0) {
	//		ret = pcmplay(wav);
	//		sprintf(string, "fmt:%d,ch:%d,bit:%d,pcm:0x%X,0x%X", wav->dataformat, wav->channels, wav->bits, wav->pcm[0], wav->pcmlen);
	//		msgbox(string, shtctl);
	//		//sprintf(string, "retval:%d,wav:%d", pcmplay(wav), wav_Is_error);
	//		//msgbox(string, shtctl);
	//	} else {
	//		sprintf(string, "error: %d", wav_Is_error);
	//		msgbox(string, shtctl);
	//	}
	//} else {
	//	msgbox("\'mogex.wav\' is not found.", shtctl);
	//}

	/* Adlib */
	M_ADLIB = found_adlib(fat);
	adlib_patch_sine();
	adlib_load_patch(0);
	adlib_play(0, 440, 63);

	/* sht_cons */
	ActiveSheet = open_console(shtctl, memtotal);

	/* V[gꊇ\ */
	sheet_slide(sht_back,  0,  0);
	sheet_slide(sht_button,  2,  480-24);
	sheet_slide(ActiveSheet,   32, 4);
	sheet_slide(sht_mouse, mx, my);
	sheet_updown(sht_back,  0);
	sheet_updown(ActiveSheet,   1);
	sheet_updown(sht_button,  2);
	sheet_updown(sht_mouse, MAX_SHEETS);
	keywin_on(ActiveSheet);

	/* help */
	if (BT_HELP == 1)
	{
		cons_runcmd("help", 0, fat, memtotal);
	}

	/* startup */
	finfo = file_search(OS_SCRIPT, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);
	if (finfo != 0) {
		char *ss;
		i = finfo->size;
		ss = file_loadfile2(finfo->clustno, &i, fat);
		for (x = 0; x < i; x++) {
			if (ss[x] != 0x0d) {
				fifo32_put(&ActiveSheet->task->fifo, ss[x] + 256);
			}
		}
	}
	
	adlib_stop(0);

	memman_free_4k(memman, (int) fat, 4 * 2880);

	/* 烁C[v */

	for (;;) {
		if (fifo32_status(&keycmd) > 0 && keycmd_wait < 0) {
			/* L[{[hRg[ɑf[^΁A */
			keycmd_wait = fifo32_get(&keycmd);
			wait_KBC_sendready();
			io_out8(PORT_KEYDAT, keycmd_wait);
		}
		io_cli();
		if (fifo32_status(&fifo) == 0) {
			/* FIFOۂɂȂ̂ŁAۗĂ`悪Ύs */
			if (new_mx >= 0) {
				io_sti();
				sheet_slide(sht_mouse, new_mx, new_my);
				new_mx = -1;
			} else if (new_wx != 0x7fffffff) {
				io_sti();
				sheet_slide(sht, new_wx, new_wy);
				new_wx = 0x7fffffff;
			} else {
				task_sleep(task_a);
				io_sti();
			}
		} else {
			i = fifo32_get(&fifo);
			io_sti();
			if (ActiveSheet != 0 && ActiveSheet->flags == 0) {	/* EBhEꂽ */
				if (shtctl->top == 1) {	/* }EXƔwiȂ */
					ActiveSheet = 0;
				} else {
					ActiveSheet = shtctl->sheets[shtctl->top - 1];
					keywin_on(ActiveSheet);
				}
			}
			if (256 <= i && i <= 511) { /* L[{[hf[^ */
				if (i < 0x80 + 256) { /* L[R[h𕶎R[hɕϊ */
					if (key_shift == 0) {
						s[0] = keytable0[i - 256];
					} else {
						s[0] = keytable1[i - 256];
					}
				} else {
					s[0] = 0;
				}
				if ('A' <= s[0] && s[0] <= 'Z') {	/* ͕At@xbg */
					if (((key_leds & 4) == 0 && key_shift == 0) ||
							((key_leds & 4) != 0 && key_shift != 0)) {
						s[0] += 0x20;	/* 啶ɕϊ */
					}
				}
				if (s[0] != 0 && ActiveSheet != 0) { /* ʏ핶AobNXy[XAEnter */
					fifo32_put(&ActiveSheet->task->fifo, s[0] + 256);
				}
				if (i == 256 + 0x0f && ActiveSheet != 0) {	/* Tab */
					keywin_off(ActiveSheet);
					j = ActiveSheet->height - 1;
					if (j == 0) {
						j = shtctl->top - 1;
					}
					ActiveSheet = shtctl->sheets[j];
					keywin_on(ActiveSheet);
				}
				if (i == 256 + 0x2a) {	/* Vtg ON */
					key_shift |= 1;
				}
				if (i == 256 + 0x36) {	/* EVtg ON */
					key_shift |= 2;
				}
				if (i == 256 + 0xaa) {	/* Vtg OFF */
					key_shift &= ~1;
				}
				if (i == 256 + 0xb6) {	/* EVtg OFF */
					key_shift &= ~2;
				}
				if (i == 256 + 0x38) {	/* Alt ON */
					key_alt = 1;
				}
				if (i == 256 + 0xb8) {	/* Alt OFF */
					key_alt = 0;
				}
				if (i == 256 + 0x1d) {	/* Ctrl ON */
					key_ctrl = 1;
				}
				if (i == 256 + 0x9d) {	/* Ctrl OFF */
					key_ctrl = 0;
				}
				if (i == 256 + 0x3a) {	/* CapsLock */
					key_leds ^= 4;
					fifo32_put(&keycmd, KEYCMD_LED);
					fifo32_put(&keycmd, key_leds);
				}
				if (i == 256 + 0x45) {	/* NumLock */
					key_leds ^= 2;
					fifo32_put(&keycmd, KEYCMD_LED);
					fifo32_put(&keycmd, key_leds);
				}
				if (i == 256 + 0x46) {	/* ScrollLock */
					key_leds ^= 1;
					fifo32_put(&keycmd, KEYCMD_LED);
					fifo32_put(&keycmd, key_leds);
				}
				if (i == 256 + 0x3b && key_shift != 0 && ActiveSheet != 0) {	/* Shift+F1 */
					task = ActiveSheet->task;
					if (task != 0 && task->tss.ss0 != 0) {
						cons_putstr0(task->cons, APP_KEYEND);
						io_cli();	/* IɃ^XNςƍ邩 */
						task->tss.eax = (int) &(task->tss.esp0);
						task->tss.eip = (int) asm_end_app;
						io_sti();
						task_run(task, -1, 0);	/* Imɂ点邽߂ɁAQĂN */
					}
				}
				if (i == 256 + 0x3c && key_shift != 0) {	/* Shift+F2 */
					/* VR\[͑IԂɂîقe؂ˁHj */
					if (ActiveSheet != 0) {
						keywin_off(ActiveSheet);
					}
					ActiveSheet = open_console(shtctl, memtotal);
					sheet_slide(ActiveSheet, 32, 32);
					sheet_updown(ActiveSheet, shtctl->top);
					keywin_on(ActiveSheet);
				}
				if (i == 256 + 0x3d && key_shift != 0) {	/* Shift+F3 */
					sys_reset();
				}
				if (i == 256 + 0x3e && key_shift != 0) {	/* Shift+F4 */
					os_ver();
				}
				if (i == 256 + 0x3b && key_alt != 0) {		/* Alt+F1 */
					for (i = 0; i < 16 * 256; i++) {
						nihongo[i] = hankaku[i];
					}
					*((int *) 0x0fe8) = (int) nihongo;
					goto skipkey;
				}
				if (i == 256 + 0x44 && key_ctrl != 0) {		/* Ctrl+F10 */
					cons_runcmd("help cmd", 0, fat, memtotal);
					goto skipkey;
				}
				if (i == 256 + 0x44) {	/* F10 */
					cons_runcmd("help", 0, fat, memtotal);
				}
				if (i == 256 + 0x57) {	/* F11 */
					sheet_updown(shtctl->sheets[1], shtctl->top - 1);
				}
skipkey:		if (i == 256 + 0xfa) {	/* L[{[hf[^𖳎Ɏ󂯎 */
					keycmd_wait = -1;
				}
				if (i == 256 + 0xfe) {	/* L[{[hf[^𖳎Ɏ󂯎Ȃ */
					wait_KBC_sendready();
					io_out8(PORT_KEYDAT, keycmd_wait);
				}
			} else if (512 <= i && i <= 767) { /* }EXf[^ */
				if (mouse_decode(&mdec, i - 512) != 0) {
					/* }EXJ[\̈ړ */
					mx += mdec.x;
					my += mdec.y;
					minfo.x = mx;
					minfo.y = my;
					if (mx < 0) {
						mx = 0;
					}
					if (my < 0) {
						my = 0;
					}
					if (mx > binfo->scrnx - 1) {
						mx = binfo->scrnx - 1;
					}
					if (my > binfo->scrny - 1) {
						my = binfo->scrny - 1;
					}
					new_mx = mx;
					new_my = my;
					if ((mdec.btn & 0x01) != 0) {
						/* {^Ă */
						if (mmx < 0) {
							/* ʏ탂[h̏ꍇ */
							/* ̉珇ԂɃ}EXwĂ鉺T */
							for (j = shtctl->top - 1; j > 0; j--) {
								sht = shtctl->sheets[j];
								x = mx - sht->vx0;
								y = my - sht->vy0;
								if (0 <= x && x < sht->bxsize && 0 <= y && y < sht->bysize) {
									if (sht->buf[y * sht->bxsize + x] != sht->col_inv) {
										if ((sht->flags & 0x200) != 0) {
											close_menu(sht_menu);
											menuIsOn = 0;
											menuIsClosed = 0;
											put_button(sht_button, menuIsOn);
											continue;
										}
										if ((sht->flags & 0x100) == 0) {
											sheet_updown(sht, shtctl->top - 1);
											if (menuIsClosed != 0) {
												close_menu(sht_menu);
												menuIsOn = 0;
												menuIsClosed = 0;
												put_button(sht_button, menuIsOn);
											}
											if (sht != ActiveSheet) {
												keywin_off(ActiveSheet);
												ActiveSheet = sht;
												keywin_on(ActiveSheet);
											}
											if (3 <= x && x < sht->bxsize - 3 && 3 <= y && y < 21) {
												mmx = mx;	/* EBhEړ[h */
												mmy = my;
												mmx2 = sht->vx0;
												new_wy = sht->vy0;
											}
											if (sht->bxsize - 21 <= x && x < sht->bxsize - 5 && 5 <= y && y < 19) {
												/* u~v{^NbN */
												if ((sht->flags & 0x10) != 0) {		/* AvEBhEH */
													task = sht->task;
													cons_putstr0(task->cons, APP_MSEEND);
													io_cli();	/* IɃ^XNςƍ邩 */
													task->tss.eax = (int) &(task->tss.esp0);
													task->tss.eip = (int) asm_end_app;
													io_sti();
													task_run(task, -1, 0);
												} else if ((sht->flags & 13) != 0) { /* _CAO */
													sheet_updown(sht, -1);
													keywin_off(ActiveSheet);
													ActiveSheet = shtctl->sheets[shtctl->top - 1];
													keywin_on(ActiveSheet);
												} else {	/* R\[ */
													task = sht->task;
													sheet_updown(sht, -1); /* Ƃ肠\ɂĂ */
													keywin_off(ActiveSheet);
													ActiveSheet = shtctl->sheets[shtctl->top - 1];
													keywin_on(ActiveSheet);
													io_cli();
													fifo32_put(&task->fifo, 4);
													io_sti();
												}
											}
										} else if ((sht->flags & 0x100) != 0) {
											if (menuIsOn == 0) {
												/* Ƀ{^ [ON] ɂȂƂ̃vO܂B */
												sht_menu = init_menu(shtctl, task_now());
												menuIsOn = 1;
												menuIsClosed = 1;
											} else {
												/* Ƀ{^ [OFF] ɂȂƂ̃vO܂B */
												close_menu(sht_menu);
												menuIsOn = 0;
												menuIsClosed = 0;
											}
											put_button(sht_button, menuIsOn);
										}
										break;
									}
								}
							}
						} else {
							/* EBhEړ[h̏ꍇ */
							x = mx - mmx;	/* }EẌړʂvZ */
							y = my - mmy;
							new_wx = (mmx2 + x + 2) & ~3;
							new_wy = new_wy + y;
							mmy = my;	/* ړ̍WɍXV */
						}
					} else {
						/* {^ĂȂ */
						mmx = -1;	/* ʏ탂[h */
						if (new_wx != 0x7fffffff) {
							sheet_slide(sht, new_wx, new_wy);	/* xm肳 */
							new_wx = 0x7fffffff;
						}
					}
				}
			} else if (768 <= i && i <= 1023) {	/* R\[I */
				close_console(shtctl->sheets0 + (i - 768));
			} else if (1024 <= i && i <= 2023) {
				close_constask(taskctl->tasks0 + (i - 1024));
			} else if (2024 <= i && i <= 2279) {	/* R\[ */
				sht2 = shtctl->sheets0 + (i - 2024);
				memman_free_4k(memman, (int) sht2->buf, 256 * 165);
				sheet_free(sht2);
			}
		}
	}
}

void keywin_off(struct SHEET *key_win)
{
	change_wtitle8(key_win, 0);
	if ((key_win->flags & 0x20) != 0) {
		fifo32_put(&key_win->task->fifo, 3); /* R\[̃J[\OFF */
	}
	return;
}

void keywin_on(struct SHEET *key_win)
{
	change_wtitle8(key_win, 1);
	if ((key_win->flags & 0x20) != 0) {
		fifo32_put(&key_win->task->fifo, 2); /* R\[̃J[\ON */
	}
	return;
}

struct TASK *open_constask(struct SHEET *sht, unsigned int memtotal)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct TASK *task = task_alloc();
	int *cons_fifo = (int *) memman_alloc_4k(memman, 128 * 4);
	task->cons_stack = memman_alloc_4k(memman, 64 * 1024);
	task->tss.esp = task->cons_stack + 64 * 1024 - 12;
	task->tss.eip = (int) &console_task;
	task->tss.es = 1 * 8;
	task->tss.cs = 2 * 8;
	task->tss.ss = 1 * 8;
	task->tss.ds = 1 * 8;
	task->tss.fs = 1 * 8;
	task->tss.gs = 1 * 8;
	*((int *) (task->tss.esp + 4)) = (int) sht;
	*((int *) (task->tss.esp + 8)) = memtotal;
	task_run(task, 2, 2); /* level=2, priority=2 */
	fifo32_init(&task->fifo, 128, cons_fifo, task);
	return task;
}

struct SHEET *open_console(struct SHTCTL *shtctl, unsigned int memtotal)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned char *buf = (unsigned char *) memman_alloc_4k(memman, 256 * 165);
	sheet_setbuf(sht, buf, 256, 165, -1); /* FȂ */
	make_window8(buf, 256, 165, CONS_TITLE, 0);
	make_textbox8(sht, 8, 28, 240, 128, 94);
	sht->task = open_constask(sht, memtotal);
	sht->flags |= 0x20;	/* J[\ */
	return sht;
}

void close_constask(struct TASK *task)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	task_sleep(task);
	memman_free_4k(memman, task->cons_stack, 64 * 1024);
	memman_free_4k(memman, (int) task->fifo.buf, 128 * 4);
	io_cli();
	task->flags = 0; /* task_free(task); ̑ */
	if (taskctl->task_fpu == task) {
		taskctl->task_fpu = 0;
	}
	io_sti();
	return;
}

void close_console(struct SHEET *sht)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct TASK *task = sht->task;
	memman_free_4k(memman, (int) sht->buf, 256 * 165);
	sheet_free(sht);
	close_constask(task);
	return;
}

void sys_reset(void) //VXeZbg܂B
{
	io_cli(); io_out8(PORT_KEYCMD, 0xfe); for (;;){/* ȂɂB_(^o^)^ */};
	return;
}

void sys_shutdown(void) //Vbg_E܂B
{
	
}


void put_clockfont_sht(struct SHEET *sht, int x, int y, int c, char *s, int len);
int cnt;

inline void sysclock_task(void)
{
	int i;
	unsigned char s[7], t[7];
	struct TASK *task = task_now();
	struct TIMER *clock_timer = timer_alloc();

	timer_init(clock_timer, &task->fifo, 1);
	timer_settime(clock_timer, 100);

	for (;;) {

		io_cli();

		if (fifo32_status(&task->fifo) == 0) {

			task_sleep(task);
			io_sti();

		} else {

			i = fifo32_get(&task->fifo);
			io_sti();

			if (i == 1) {
				struct SHTCTL *ctl = (struct SHTCTL *) *((int *) 0x0fe4);
				struct SHEET *sht = &ctl->sheets0[0];

				readrtc(t);		// RTCǂݍ

				sprintf(s, "%02X%s%02X", t[2], (cnt % 2 == 0)? ":" : " ", t[1]);
				boxfill8(sht->buf, sht->bxsize, COL8___BASE,
					sht->bxsize - 45, sht->bysize - 17,
					sht->bxsize - 45 + 5 * 8 - 1, sht->bysize - 17 + 15);
				put_clockfont_sht(sht, sht->bxsize - 47, sht->bysize - 17, COL8_000000, s, 5);

				timer_settime(clock_timer, 100);
				cnt++;
			}
		}
	}
}

/* end of bootpack.c */
